-- MoonTimeLayoutObj.lua

function MoonTimeLayoutObj()
	-- dieses Frame besitzt die Funktionen:
	-- GetStarrainCD
	-- GetTreantsCD
	-- GetStarsurgeCD
	-- GetMoonfireCD
	-- GetInsectSwarmCD
	-- GetEclipseEndTimes
	-- Next()
	local frame = CreateFrame( "Frame" )
	
	local expirationTime, start, duration, enabled, unitCaster, name, texture, active
	local hpdiff, timediff, timetilldeath, dir, power, EDir, EPower, spell, startTime, endTime, castID, change, charges, maxCharges, start, duration, count
	local masteryrating, isLunarEmpowered, isSolarEmpowered
	
	
	
	frame.GetStarfallDuration = function()
		_, _, _, _, _, _, expirationTime = UnitBuff("player", SR_name) 
		
		if expirationTime == nil then 
			return 0
		end
		
		return expirationTime-GetTime();
	end
	
	frame.GetTreantsCD = function()
		start, duration, enabled = GetSpellCooldown(Treants_id);
		
		return start+duration-GetTime();
	end
	
	frame.GetStarsurgeCD = function()
		start, duration, enabled = GetSpellCooldown(SS_id);
		return start+duration-GetTime();
	end
	
	frame.GetMoonfireCD = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitDebuff("target", MF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
			else
			return -1, GetTime();
		end
	end
	
	frame.GetSunfireCD = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitDebuff("target", SunF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
			else
			return -1, GetTime();
		end
	end
	
	frame.GetFaerieFireCD = function()
		_, _, _, _, _, _, expirationTime, unitCaster = UnitDebuff("target", FF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime();
			else
			return -1;
		end
	end
	
	frame.GetCelestialAlignmentCD = function()
		start, duration = GetSpellCooldown(CA_id);
		return start+duration-GetTime();
	end	
	
	frame.GetTalentCD = function( self, row, col )
		_, name, texture, active = GetTalentInfo( row, col, GetActiveSpecGroup())
		
		if active then
			start, duration, enabled = GetSpellCooldown(name);	
			if duration < 2 then return 0, duration end
			return start+duration-GetTime(), duration;
			else
			return -1, 0
		end
	end
	
	frame.GetRejuvenationDuration = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitBuff("player", R_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
			else
			return -1;
		end			
	end	
	
	
	frame.GetEclipseDirection = function()
		dir = GetEclipseDirection()
		
		--DEFAULT_CHAT_FRAME:AddMessage(dir)
		
		if ( dir == "none" ) then
			dir = "moon";
		end
		local power = UnitPower("player", 8)
		
		return dir, power
	end
	
	
	
	frame.GetCelestialAlignmentDuration = function()
		name, _, _, _, _, _, expirationTime = UnitBuff("player", CA_name);
		
		if name then
			return expirationTime-GetTime();
			else
			return -1
		end
	end	
	
	
	
	frame.GetCharges = function ()
		charges, maxCharges, start, duration = GetSpellCharges(SS_id)
		
		if charges == maxCharges then
			return charges, -1
			else
			return charges, start+duration-GetTime()
		end
	end
	
	
	frame.IsLunarEmpowered = function ()
		name, _, _, count = UnitBuff("player", LE_name)
		
		if name then
			return count
			else
			return 0
		end
	end	
	
	frame.IsSolarEmpowered = function ()
		name, _, _, count = UnitBuff("player", SE_name)
		
		if name then
			return count
			else
			return 0
		end
	end	
	
	
	frame.IsLunarPeak = function ()
		name = UnitBuff("player", LP_name)
		
		if name then
			return true
			else
			return false
		end
	end	
	
	frame.IsSolarPeak = function ()
		name = UnitBuff("player", SP_name)
		
		if name then
			return true
			else
			return false
		end
	end	
	
	
	
	frame.IsEmpowered = function ()	
		isLunarEmpowered = frame.IsLunarEmpowered()
		isSolarEmpowered = frame.IsSolarEmpowered()
		if frame.IsLunarEmpowered() or frame.IsSolarEmpowered() then
			return true
			else
			return false
		end
	end
	
	
	local peak = GetTime()
	
	local mpeak, mc, mPower, EDir, EPower, c, compPower, newpeak, a, cl
	
	frame.GetFuturePower = function(t)
		EDir, EPower = frame.GetEclipseDirection()
		cl = 40
		if frame.GetSetTalentInRow(7) == 1 then
			cl = 20
		end
		
		c = GetTime()-peak
		compPower = min(max(-round(cos((c)*(360/cl))*105),-100),100)		
		
		
		
		if abs(EPower) < 100 then
			if compPower ~= EPower then
				if EDir == "moon" then
					newpeak = GetTime()+(-acos(EPower/105)/(360/cl)-cl/2)
					else
					newpeak = GetTime()-acos(-EPower/105)/(360/cl)
				end
				
				-- for a = 1,3 do
				while compPower ~= EPower do
					peak = peak/2 + newpeak/2
					c = GetTime()-peak
					compPower = min(max(-round(cos((c)*(360/cl))*105),-100),100)	
					
					-- if compPower == EPower then
					-- newpeak = mpeak
					-- else
					-- peak = mpeak
					-- end
				end
				
				c = GetTime()-peak
				-- compPower = min(max(-round(cos((c)*(360/cl))*105),-100),100)				
			end
		end	
		EPower = min(max(-round(cos((c+t)*(360/cl))*105),-100),100)
		
		return EPower
		
	end
	
	
	
	
	
	-- 58.66 rating @100 ?
	frame.GetLunarAmp = function(t)
		return 1 + (100-frame.GetFuturePower(t))/200 * (GetCombatRating(CR_MASTERY)/12.26+15)/100
	end
	
	frame.GetSolarAmp = function(t)
	return 1 + (100+frame.GetFuturePower(t))/200 * (GetCombatRating(CR_MASTERY)/12.26+15)/100
	end
	
	
	
	frame.isSolar = function(t)
	if not t then t=0 end
	
	if frame.GetFuturePower(t) > 0 then
	return true
	else
	return false
	end
	end
	
	frame.isLunar = function(t)
	return not frame.isSolar(t)
	end
	
	
	frame.GetSetTalentInRow = function(n)
	for a = 1,3 do
	local _,_,_,set = GetTalentInfo(n,a,GetActiveSpecGroup())
	if set then
	return a
	end
	end
	return 0
	end
	
	
	
	return frame
	end
	
		